VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Sort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'---------------------------------------------------------------------'
'                                                                     '
' S A S S o r t . D L L                                               '
'                                                                     '
' Enterprise Guide Add-In Task Example                                '
'                                                                     '
' (C) 2002, SAS Institute Inc.                                        '
'                                                                     '
' By SUKDGM  July 2002                                                '
'                                                                     '
'---------------------------------------------------------------------'

Option Explicit

Implements SEGAddIn
Implements SEGTask
Implements SEGTaskInfo
Implements SEGErrorSink
Implements SEGDataSink

Private TaskUI As SortTaskDialog

Private Sub SEGAddIn_Connect(ByVal ppiApplication As SASAIOBJLib.ISEGApplication, ByVal lCookie As Long, plSuccess As Long)
    Set TaskUI = New SortTaskDialog
    Set TaskUI.Application = ppiApplication
    plSuccess = APP_CONNECTION_SUCCESS
End Sub

Private Sub SEGAddIn_Disconnect()
    Unload TaskUI
End Sub

Private Sub SEGAddIn_GetDescription(pbstrVal As String)
    pbstrVal = "Sorts tables"
End Sub

Private Sub SEGAddIn_GetName(pbstrVal As String)
    pbstrVal = "Sort"
End Sub

Private Sub SEGDataSink_ActiveDataChanged()
    ' TODO (Optional):
End Sub

Private Sub SEGDataSink_GenerateOutputData(plSuccess As Long)
    ' TODO (Optional):
End Sub

Private Sub SEGDataSink_GenerateOutputDataNames()
    ' TODO (Optional):
End Sub

Private Sub SEGErrorSink_ExecutionError(ByVal lErrorCode As Long, ByVal bstrDescription As String, ByVal bstrProgID As String, ByVal bstrMethod As String, ByVal bstrParameter As String)
    ' TODO (Optional):
End Sub

Private Sub SEGTask_GetOptionsFlag(plOptions As Long)
    plOptions = APP_TASK_CATEGORY_DATA
End Sub

Private Sub SEGTask_GetOutputDataCount(plCount As Long)
    plCount = 1
End Sub

Private Sub SEGTask_GetOutputDataInfo(ByVal lIndex As Long, pbstrSource As String, pbstrLabel As String, plFile As Long)
    Select Case lIndex
        Case 0:
            pbstrSource = TaskUI.SASDSSel.LibraryName & "." & TaskUI.SASDSSel.DatasetName
            pbstrLabel = TaskUI.GetDataSetLabel()
            plFile = APP_OUTPUTDATA_LIBREF
    End Select
End Sub

Private Sub SEGTask_GetProperty(ByVal bstrKey As String, pbstrVal As String)
    Select Case bstrKey
        Case ROLE_COLUMNSTORETAIN
            pbstrVal = TaskUI.RoleValues(ROLE_COLUMNSTORETAIN)
        Case ROLE_SORTBY
            pbstrVal = TaskUI.RoleValues(ROLE_SORTBY)
        Case "Duplicate records"
            pbstrVal = CStr(GetCurrOption(TaskUI.rbtnDuplicates))
        Case "EQUALS"
            pbstrVal = CStr(TaskUI.chkEQUALS.Value)
        Case "Collation"
            pbstrVal = CStr(GetCurrOption(TaskUI.rbtnCollation))
        Case "MEMSIZE (units)"
            pbstrVal = CStr(TaskUI.combSORTSIZE.ListIndex)
        Case "MEMSIZE (value)"
            pbstrVal = TaskUI.edtSORTSIZE.Text
        Case "TAGSORT"
            pbstrVal = CStr(TaskUI.chkTAGSORT.Value)
        Case "FORCE"
            pbstrVal = CStr(TaskUI.chkFORCE.Value)
        Case "Run task now"
            pbstrVal = CStr(TaskUI.chkRunTask.Value)
        Case "Output Library"
            pbstrVal = TaskUI.SASDSSel.LibraryName
        Case "Output Dataset"
            pbstrVal = TaskUI.SASDSSel.DatasetName
    End Select
End Sub

Private Sub SEGTask_GetPropertyList(pbstrKeyArray() As String)
    ReDim pbstrKeyArray(12) As String
    
    pbstrKeyArray(0) = ROLE_COLUMNSTORETAIN
    pbstrKeyArray(1) = ROLE_SORTBY
    pbstrKeyArray(2) = "Duplicate records"
    pbstrKeyArray(3) = "EQUALS"
    pbstrKeyArray(4) = "Collation"
    pbstrKeyArray(5) = "MEMSIZE (units)"
    pbstrKeyArray(6) = "MEMSIZE (value)"
    pbstrKeyArray(7) = "TAGSORT"
    pbstrKeyArray(8) = "FORCE"
    pbstrKeyArray(9) = "Run task now"
    pbstrKeyArray(11) = "Output Library"
    pbstrKeyArray(12) = "Output Dataset"
End Sub

Private Sub SEGTask_GetRequiresData(plVal As Long)
    plVal = APP_DATAOPTION_REQUIRED
End Sub

Private Sub SEGTask_GetRunLog(pbstrVal As String)
    ' TODO (Optional):
End Sub

Private Sub SEGTask_GetSubmitCode(pbstrCode As String)
    pbstrCode = TaskUI.Code()
End Sub

Private Sub SEGTask_Initialize(plSuccess As Long)
    TaskUI.Initialize
    plSuccess = APP_INITIALIZE_SUCCESS
End Sub

Private Sub SEGTask_SetProperty(ByVal strKey As String, ByVal strVal As String)
    Select Case strKey
        Case ROLE_COLUMNSTORETAIN
            TaskUI.AssignRoleValues ROLE_COLUMNSTORETAIN, strVal
        Case ROLE_SORTBY
            TaskUI.AssignRoleValues ROLE_SORTBY, strVal
        Case "Duplicate records"
            TaskUI.rbtnDuplicates.Item(CInt(strVal)).Value = True
        Case "EQUALS"
            TaskUI.chkEQUALS.Value = CInt(strVal)
        Case "Collation"
            TaskUI.rbtnCollation.Item(CInt(strVal)).Value = True
        Case "MEMSIZE (units)"
            TaskUI.combSORTSIZE.ListIndex = CInt(strVal)
            TaskUI.edtSORTSIZE.Enabled = (CInt(strVal) > 1)
        Case "MEMSIZE (value)"
            TaskUI.edtSORTSIZE.Text = strVal
        Case "TAGSORT"
            TaskUI.chkTAGSORT.Value = CInt(strVal)
        Case "FORCE"
            TaskUI.chkFORCE.Value = CInt(strVal)
        Case "Run task now"
            TaskUI.chkRunTask.Value = CInt(strVal)
        Case "Output Library"
            TaskUI.SASDSSel.LibraryName = strVal
        Case "Output Dataset"
            TaskUI.SASDSSel.DatasetName = strVal
    End Select
End Sub

Private Sub SEGTask_Show(ByVal lParentWindowHandle As Long, plStatus As Long)
    ' HKEY_CURRENT_USER\Software\SAS Institute Inc.\Enterprise Guide\2.0\Settings\TaskWindowPosition
    ' Display the main task dialog
    TaskUI.Show vbModal
    
    ' Process the reason for the task dialog terminating
    If TaskUI.bCancelled = True Then
        plStatus = APP_SHOW_CANCELED
    Else
' APP_SHOW_RUNLATER functionality not supported in Enterprise Guide 2.0...
'        If TaskUI.chkRunTask.Value = 0 Then
'            plStatus = APP_SHOW_RUNLATER
'        Else
'            plStatus = APP_SHOW_RUNNOW
'        End If
' ...for now we'll always run the task so long as the task wasn't cancelled
        plStatus = APP_SHOW_RUNNOW
    End If
End Sub

Private Sub SEGTask_Terminate()
    TaskUI.Terminate
    Unload TaskUI
End Sub

Private Sub SEGTaskInfo_GetTaskCategory(pbstrVal As String)
    pbstrVal = "Data"
End Sub

Private Sub SEGTaskInfo_GetTaskDescription(pbstrVal As String)
    pbstrVal = "Sorts Tables"
End Sub

Private Sub SEGTaskInfo_GetTaskMajorVersion(plVal As Long)
    plVal = 1
End Sub

Private Sub SEGTaskInfo_GetTaskMinorVersion(plVal As Long)
    plVal = 0
End Sub

Private Sub SEGTaskInfo_GetTaskName(pbstrVal As String)
    pbstrVal = "Sort Data"
End Sub

Private Sub SEGTaskInfo_GetTaskProcsUsed(pbstrVal As String)
    pbstrVal = "SORT"
End Sub

Private Sub SEGTaskInfo_GetTaskType(plType As Long)
    plType = APP_TASKTYPE_WIZARD
End Sub

Private Sub SEGTaskInfo_GetTaskValidation(pbstrVal As String)
    ' TODO (Optional):
End Sub
